/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ReportConfigurationDataSortInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportConfigurationDataSortInner{}

// ReportConfigurationDataSortInner struct for ReportConfigurationDataSortInner
type ReportConfigurationDataSortInner struct {
	By *ReportGroupBy `json:"by,omitempty"`
	Dir *string `json:"dir,omitempty"`
}

// NewReportConfigurationDataSortInner instantiates a new ReportConfigurationDataSortInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportConfigurationDataSortInner() *ReportConfigurationDataSortInner {
	this := ReportConfigurationDataSortInner{}
	return &this
}

// NewReportConfigurationDataSortInnerWithDefaults instantiates a new ReportConfigurationDataSortInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportConfigurationDataSortInnerWithDefaults() *ReportConfigurationDataSortInner {
	this := ReportConfigurationDataSortInner{}
	return &this
}

// GetBy returns the By field value if set, zero value otherwise.
func (o *ReportConfigurationDataSortInner) GetBy() ReportGroupBy {
	if o == nil || IsNil(o.By) {
		var ret ReportGroupBy
		return ret
	}
	return *o.By
}

// GetByOk returns a tuple with the By field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationDataSortInner) GetByOk() (*ReportGroupBy, bool) {
	if o == nil || IsNil(o.By) {
		return nil, false
	}
	return o.By, true
}

// HasBy returns a boolean if a field has been set.
func (o *ReportConfigurationDataSortInner) HasBy() bool {
	if o != nil && !IsNil(o.By) {
		return true
	}

	return false
}

// SetBy gets a reference to the given ReportGroupBy and assigns it to the By field.
func (o *ReportConfigurationDataSortInner) SetBy(v ReportGroupBy) {
	o.By = &v
}

// GetDir returns the Dir field value if set, zero value otherwise.
func (o *ReportConfigurationDataSortInner) GetDir() string {
	if o == nil || IsNil(o.Dir) {
		var ret string
		return ret
	}
	return *o.Dir
}

// GetDirOk returns a tuple with the Dir field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationDataSortInner) GetDirOk() (*string, bool) {
	if o == nil || IsNil(o.Dir) {
		return nil, false
	}
	return o.Dir, true
}

// HasDir returns a boolean if a field has been set.
func (o *ReportConfigurationDataSortInner) HasDir() bool {
	if o != nil && !IsNil(o.Dir) {
		return true
	}

	return false
}

// SetDir gets a reference to the given string and assigns it to the Dir field.
func (o *ReportConfigurationDataSortInner) SetDir(v string) {
	o.Dir = &v
}

func (o ReportConfigurationDataSortInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportConfigurationDataSortInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.By) {
		toSerialize["by"] = o.By
	}
	if !IsNil(o.Dir) {
		toSerialize["dir"] = o.Dir
	}
	return toSerialize, nil
}

type NullableReportConfigurationDataSortInner struct {
	value *ReportConfigurationDataSortInner
	isSet bool
}

func (v NullableReportConfigurationDataSortInner) Get() *ReportConfigurationDataSortInner {
	return v.value
}

func (v *NullableReportConfigurationDataSortInner) Set(val *ReportConfigurationDataSortInner) {
	v.value = val
	v.isSet = true
}

func (v NullableReportConfigurationDataSortInner) IsSet() bool {
	return v.isSet
}

func (v *NullableReportConfigurationDataSortInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportConfigurationDataSortInner(val *ReportConfigurationDataSortInner) *NullableReportConfigurationDataSortInner {
	return &NullableReportConfigurationDataSortInner{value: val, isSet: true}
}

func (v NullableReportConfigurationDataSortInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportConfigurationDataSortInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


